#include <stdio.h>
#include <string.h>
#include "FormValues.h"
#include "log.h"

#define MAXENTRIES 100

class ConfigFileLoader {
public:
	ConfigFileLoader();
	void load( FILE* fp );
	void add( char* n, char* v );
	void reset();
	char* genConfigInputs();
private:
	char* name[MAXENTRIES];
	char* value[MAXENTRIES];
	int idx;
};

ConfigFileLoader::ConfigFileLoader() {
	reset();
}

char* ConfigFileLoader::genConfigInputs() {
	char buf[5000];
	buf[0] = 0;
	char tbuf[200];
	strcat( buf, "<table>\n" );
	for ( int i = 0; i < idx; i++ ) {
		sprintf( tbuf, "<tr><td>%s</td><td><input type=\"TEXT\" name=\"%s\" value=\"%s\"></td></tr>\n",
			name[i], name[i], value[i] );
		strcat( buf, tbuf );
	}
	strcat( buf, "</table>\n" );
	return( newstrcpy( buf ));
}

void ConfigFileLoader::reset() {
	idx = 0;
	for ( int i = 0; i < MAXENTRIES; i++ ) {
		name[i] = NULL;
		value[i] = NULL;
	}
}

void ConfigFileLoader::add( char* n, char* v ) {
	name[idx] = n;
	value[idx] = v;
	idx++;
}

void ConfigFileLoader::load( FILE* fp ) {
	char* line;
	while (( line = file_line( fp )) != NULL ) {
		char* scanner = line;
		char* n = line;
		char* v = NULL;
		while ( *scanner ) {
			if ( *scanner == '=' ) {
				*scanner = 0;
				v = scanner + 1;
				break;
			}
			scanner++;
		}
		if ( v != NULL ) {
			add( n, v );
		}
	}
}


ConfigFileLoader configurator;


void load_config_file( char* configFileName ) {
	configurator.reset();
	if ( configFileName != NULL ) {
		FILE* fp = fopen( configFileName, "rb" );
		if ( fp != NULL ) {
			configurator.load( fp );
			fclose( fp );
		}
	}
}

char* gen_config_inputs() {
	return( configurator.genConfigInputs() );
}

void config_file( FormValues* fv ) {
	char* configFileName = fv->grabValue( "config_file" );
	load_config_file( configFileName );
}
